<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SupplementRelPaxDist ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SupplementRelPaxDist extends AbstractStructArrayBase
{
    /**
     * The SupplementRelPaxDist
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SupplementRelPaxDist[]
     */
    public $SupplementRelPaxDist;
    /**
     * Constructor method for ArrayOfJP_SupplementRelPaxDist
     * @uses ArrayOfJP_SupplementRelPaxDist::setSupplementRelPaxDist()
     * @param \StructType\JP_SupplementRelPaxDist[] $supplementRelPaxDist
     */
    public function __construct(array $supplementRelPaxDist = array())
    {
        $this
            ->setSupplementRelPaxDist($supplementRelPaxDist);
    }
    /**
     * Get SupplementRelPaxDist value
     * @return \StructType\JP_SupplementRelPaxDist[]|null
     */
    public function getSupplementRelPaxDist()
    {
        return $this->SupplementRelPaxDist;
    }
    /**
     * Set SupplementRelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPaxDist[] $supplementRelPaxDist
     * @return \ArrayType\ArrayOfJP_SupplementRelPaxDist
     */
    public function setSupplementRelPaxDist(array $supplementRelPaxDist = array())
    {
        foreach ($supplementRelPaxDist as $arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem instanceof \StructType\JP_SupplementRelPaxDist) {
                throw new \InvalidArgumentException(sprintf('The SupplementRelPaxDist property can only contain items of \StructType\JP_SupplementRelPaxDist, "%s" given', is_object($arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem) ? get_class($arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem) : gettype($arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem)), __LINE__);
            }
        }
        $this->SupplementRelPaxDist = $supplementRelPaxDist;
        return $this;
    }
    /**
     * Add item to SupplementRelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPaxDist $item
     * @return \ArrayType\ArrayOfJP_SupplementRelPaxDist
     */
    public function addToSupplementRelPaxDist(\StructType\JP_SupplementRelPaxDist $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SupplementRelPaxDist) {
            throw new \InvalidArgumentException(sprintf('The SupplementRelPaxDist property can only contain items of \StructType\JP_SupplementRelPaxDist, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SupplementRelPaxDist[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SupplementRelPaxDist
     */
    public function getAttributeName()
    {
        return 'SupplementRelPaxDist';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_SupplementRelPaxDist
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
